#define __CS 10
#define __DC 9


//#define ONLY_CUBE


#include <EdWgfx.h>


// Color definitions
#define  BLACK   0
#define BLUE    2
#define GREEN   4
#define CYAN    9
#define MAGENTA 10
#define RED     11
#define WHITE   14
#define YELLOW  15


EdWgfx tft = EdWgfx(__CS, __DC);


#define ___   0
#define _ww   WHITE
#define _bB   BLUE
#define _MM   MAGENTA
#define _GG   GREEN
#define _CC   YELLOW

#define duch_x  14
#define duch_y  16
const PROGMEM uint8_t duch_M[] = {
  ___, ___, ___, ___, _MM, _MM, _MM, _MM, _MM, _MM, ___, ___, ___, ___,
  ___, ___, ___, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, ___, ___, ___,
  ___, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, ___,
  ___, _MM, _MM, ___, ___, _MM, _MM, _MM, _MM, ___, ___, _MM, _MM, ___,
  _MM, _MM, _MM, ___, ___, _MM, _MM, _MM, _MM, ___, ___, _MM, _MM, _MM,
  _MM, _MM, ___, ___, ___, ___, _MM, _MM, ___, ___, ___, ___, _MM, _MM,
  _MM, _MM, ___, ___, ___, ___, _MM, _MM, ___, ___, ___, ___, _MM, _MM,
  _MM, _MM, ___, ___, ___, ___, _MM, _MM, ___, ___, ___, ___, _MM, _MM,
  _MM, _MM, _MM, ___, ___, _MM, _MM, _MM, _MM, ___, ___, _MM, _MM, _MM,
  _MM, _MM, _MM, ___, ___, _MM, _MM, _MM, _MM, ___, ___, _MM, _MM, _MM,
  _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM,
  _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM, _MM,
  _MM, _MM, ___, _MM, _MM, _MM, ___, ___, _MM, _MM, _MM, ___, _MM, _MM,
  _MM, _MM, ___, _MM, _MM, _MM, ___, ___, _MM, _MM, _MM, ___, _MM, _MM,
  _MM, ___, ___, ___, _MM, _MM, ___, ___, _MM, _MM, ___, ___, ___, _MM,
  _MM, ___, ___, ___, _MM, _MM, ___, ___, _MM, _MM, ___, ___, ___, _MM,
};

const PROGMEM uint8_t duch_G[] = {
  ___, ___, ___, ___, _GG, _GG, _GG, _GG, _GG, _GG, ___, ___, ___, ___,
  ___, ___, ___, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, ___, ___, ___,
  ___, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, ___,
  ___, _GG, _GG, _ww, _ww, _GG, _GG, _GG, _GG, _ww, _ww, _GG, _GG, ___,
  _GG, _GG, _GG, _ww, _ww, _GG, _GG, _GG, _GG, _ww, _ww, _GG, _GG, _GG,
  _GG, _GG, _ww, _ww, _ww, _ww, _GG, _GG, _ww, _ww, _ww, _ww, _GG, _GG,
  _GG, _GG, _bB, _bB, _ww, _ww, _GG, _GG, _bB, _bB, _ww, _ww, _GG, _GG,
  _GG, _GG, _bB, _bB, _ww, _ww, _GG, _GG, _bB, _bB, _ww, _ww, _GG, _GG,
  _GG, _GG, _bB, _bB, _ww, _GG, _GG, _GG, _bB, _bB, _ww, _GG, _GG, _GG,
  _GG, _GG, _GG, _ww, _ww, _GG, _GG, _GG, _GG, _ww, _ww, _GG, _GG, _GG,
  _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG,
  _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG, _GG,
  _GG, _GG, ___, _GG, _GG, _GG, ___, ___, _GG, _GG, _GG, ___, _GG, _GG,
  _GG, _GG, ___, _GG, _GG, _GG, ___, ___, _GG, _GG, _GG, ___, _GG, _GG,
  _GG, ___, ___, ___, _GG, _GG, ___, ___, _GG, _GG, ___, ___, ___, _GG,
  _GG, ___, ___, ___, _GG, _GG, ___, ___, _GG, _GG, ___, ___, ___, _GG,
};


const PROGMEM uint8_t duch_C[] = {
  ___, ___, ___, ___, _CC, _CC, _CC, _CC, _CC, _CC, ___, ___, ___, ___,
  ___, ___, ___, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, ___, ___, ___,
  ___, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, ___,
  ___, _CC, _CC, _ww, _ww, _CC, _CC, _CC, _CC, _ww, _ww, _CC, _CC, ___,
  _CC, _CC, _CC, _ww, _ww, _CC, _CC, _CC, _CC, _ww, _ww, _CC, _CC, _CC,
  _CC, _CC, _ww, _ww, _ww, _ww, _CC, _CC, _ww, _ww, _ww, _ww, _CC, _CC,
  _CC, _CC, _bB, _bB, _ww, _ww, _CC, _CC, _bB, _bB, _ww, _ww, _CC, _CC,
  _CC, _CC, _bB, _bB, _ww, _ww, _CC, _CC, _bB, _bB, _ww, _ww, _CC, _CC,
  _CC, _CC, _bB, _bB, _ww, _CC, _CC, _CC, _bB, _bB, _ww, _CC, _CC, _CC,
  _CC, _CC, _CC, _ww, _ww, _CC, _CC, _CC, _CC, _ww, _ww, _CC, _CC, _CC,
  _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC,
  _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC,
  _CC, _CC, ___, _CC, _CC, _CC, ___, ___, _CC, _CC, _CC, ___, _CC, _CC,
  _CC, _CC, ___, _CC, _CC, _CC, ___, ___, _CC, _CC, _CC, ___, _CC, _CC,
  _CC, ___, ___, ___, _CC, _CC, ___, ___, _CC, _CC, ___, ___, ___, _CC,
  _CC, ___, ___, ___, _CC, _CC, ___, ___, _CC, _CC, ___, ___, ___, _CC,
};


const PROGMEM uint8_t duch_Cb[] = {
  ___, ___, ___, ___, _CC, _CC, _CC, _CC, _CC, _CC, ___, ___, ___, ___,
  ___, ___, ___, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, ___, ___, ___,
  ___, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, ___,
  ___, _CC, _CC, _ww, _ww, _CC, _CC, _CC, _CC, _ww, _ww, _CC, _CC, ___,
  _CC, _CC, _CC, _ww, _ww, _CC, _CC, _CC, _CC, _ww, _ww, _CC, _CC, _CC,
  _CC, _CC, _ww, _ww, _ww, _ww, _CC, _CC, _ww, _ww, _ww, _ww, _CC, _CC,
  _CC, _CC, _ww, _ww, _bB, _bB, _CC, _CC, _ww, _ww, _bB, _bB, _CC, _CC,
  _CC, _CC, _ww, _ww, _bB, _bB, _CC, _CC, _ww, _ww, _bB, _bB, _CC, _CC,
  _CC, _CC, _CC, _ww, _bB, _bB, _CC, _CC, _CC, _ww, _bB, _bB, _CC, _CC,
  _CC, _CC, _CC, _ww, _ww, _CC, _CC, _CC, _CC, _ww, _ww, _CC, _CC, _CC,
  _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC,
  _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC, _CC,
  _CC, _CC, ___, _CC, _CC, _CC, ___, ___, _CC, _CC, _CC, ___, _CC, _CC,
  _CC, _CC, ___, _CC, _CC, _CC, ___, ___, _CC, _CC, _CC, ___, _CC, _CC,
  _CC, ___, ___, ___, _CC, _CC, ___, ___, _CC, _CC, ___, ___, ___, _CC,
  _CC, ___, ___, ___, _CC, _CC, ___, ___, _CC, _CC, ___, ___, ___, _CC,
};


//================================================================================================
const float sin_d[] = {
  0, 0.17, 0.34, 0.5, 0.64, 0.77, 0.87, 0.94, 0.98, 1, 0.98, 0.94,
  0.87, 0.77, 0.64, 0.5, 0.34, 0.17, 0, -0.17, -0.34, -0.5, -0.64,
  -0.77, -0.87, -0.94, -0.98, -1, -0.98, -0.94, -0.87, -0.77,
  -0.64, -0.5, -0.34, -0.17
};
const float cos_d[] = {
  1, 0.98, 0.94, 0.87, 0.77, 0.64, 0.5, 0.34, 0.17, 0, -0.17, -0.34,
  -0.5, -0.64, -0.77, -0.87, -0.94, -0.98, -1, -0.98, -0.94, -0.87,
  -0.77, -0.64, -0.5, -0.34, -0.17, 0, 0.17, 0.34, 0.5, 0.64, 0.77,
  0.87, 0.94, 0.98
};
const float d = 10;
float px[] = {
  -d,  d,  d, -d, -d,  d,  d, -d
};
float py[] = {
  -d, -d,  d,  d, -d, -d,  d,  d
};
float pz[] = {
  -d, -d, -d, -d,  d,  d,  d,  d
};

float p2x[] = {
  0, 0, 0, 0, 0, 0, 0, 0
};
float p2y[] = {
  0, 0, 0, 0, 0, 0, 0, 0
};

int r[] = {
  0, 0, 0
};


//=============================================
void setup() {
  tft.begin();
  char tftId[GFX_TURBO_ID_SIZE];
  tft.readId( tftId );
  
  Serial.begin(38400);

  char txt[100];
  Serial.print( "\n\rAkcelerator graficzny " );
  Serial.print( tftId+2 );
  Serial.print( " v" );
  Serial.println( tftId+8 );

  sprintf( txt, "Rozdzielczośc %dx%d", tft.width(), tft.height() ); Serial.println( txt );
}


//=============================================
void loop() {
  const byte fastCont = true;


  uint32_t static tPauza;
  if ( millis() > tPauza ) {
    tPauza = millis() + 31;   // Kolejna klatwa nie wcześniej niż po 35ms

    uint32_t czasRysowaniaS = millis();


//char txt[100];
//tft.begin();
//  sprintf( txt, "Rozdzielczośc %dx%d\n\r", tft.width(), tft.height() ); Serial.println( txt );


    //----- CLS -----//
    {
      byte static linia, dir = 1;

      tft.setContinue( fastCont ); // Rozkaz za rozkazem
#ifdef ONLY_CUBE
      tft.fillScreen(WHITE);
#else
      tft.fillRect( 0, 0, 127, linia, WHITE);
      tft.fillRect( 0, linia, 127, 127, RED);

      if ( dir ) linia += 5; else linia -= 5;
      if ( linia >= 120) dir = 0;
      if ( linia < 6 ) dir = 1;
#endif      
    }


    //----- Napisy -----//
        #ifndef ONLY_CUBE
    {
      {
        uint8_t static dirX = 1, dirY = 1, dirC = 1, col = 16, x, y;
        tft.setTextAtrybut( TFT_MODE_PROP ); //| TFT_MODE_TXT_BACK );
        tft.setCursor(x, y);
        tft.setTextColor( col );
        tft.setTextSize(2);
        tft.printString("EdW");

        if ( dirX ) {
          x++; if ( x > 80 ) dirX = 0;
        }
        else {
          x--; if ( x < 1 ) dirX = 1;
        }

        if ( dirY ) {
          y++; if ( y > 100 ) dirY = 0;
        }
        else {
          y--; if ( y < 1 ) dirY = 1;
        }

        if ( dirC ) {
          if ( ++col >= 218 ) dirC = 0;
        } else {
          if ( --col <= 16 ) dirC = 1;
        }
      }


      {
        uint8_t static dirX = 1, dirY = 1, dirC = 1, col = 6, x = 30, y = 64, spd;
        tft.setTextAtrybut( TFT_MODE_PROP ); //| TFT_MODE_T0XT_BACK );
        tft.setCursor(x, y);
        tft.setTextColor( col );
        tft.setTextSize(3);
        tft.printString("sas@elportal.pl");

        if ( ++spd == 3 ) {
          spd = 0;
          if ( dirX ) {
            x++; if ( x > 45 ) dirX = 0;
          }
          else {
            x--; if ( x < 1 ) dirX = 1;
          }

          if ( dirY ) {
            y++; if ( y > 110 ) dirY = 0;
          }
          else {
            y--; if ( y < 1 ) dirY = 1;
          }

          if ( dirC ) {
            if ( ++col >= 218 ) dirC = 0;
          } else {
            if ( --col <= 16 ) dirC = 1;
          }
        }
      }


      {
        uint8_t static dir = 1, y, spd;
        tft.setTextAtrybut( TFT_MODE_PROP );
        tft.setCursor(0, y);
        tft.setTextColor(BLUE);
        tft.setTextSize(1);
        tft.printString("Sprites demo");

        if ( ++spd == 2 ) {
          spd = 0;
          if ( dir ) {
            y++; if ( y > 110 ) dir = 0;
          }
          else {
            y--; if ( y < 10 ) dir = 1;
          }
        }
      }
    }
#endif


    //----- Sescian
    const byte pen = BLACK;

    tft.setContinue( fastCont ); // Rozkaz za rozkazem

    r[0] = r[0] + 1;
    r[1] = r[1] + 1;
    if (r[0] == 36) r[0] = 0;
    if (r[1] == 36) r[1] = 0;
    if (r[2] == 36) r[2] = 0;
    for (int i = 0; i < 8; i++)
    {
      float px2 = px[i];
      float py2 = cos_d[r[0]] * py[i] - sin_d[r[0]] * pz[i];
      float pz2 = sin_d[r[0]] * py[i] + cos_d[r[0]] * pz[i];

      float px3 = cos_d[r[1]] * px2 + sin_d[r[1]] * pz2;
      float py3 = py2;
      float pz3 = -sin_d[r[1]] * px2 + cos_d[r[1]] * pz2;

      float ax = cos_d[r[2]] * px3 - sin_d[r[2]] * py3;
      float ay = sin_d[r[2]] * px3 + cos_d[r[2]] * py3;
      float az = pz3 - 190;

      p2x[i] = ((tft.width()) / 2) + ax * 500 / az;
      p2y[i] = ((tft.height()) / 2) + ay * 500 / az;
    }
    for (int i = 0; i < 3; i++) {
      tft.drawLine(p2x[i], p2y[i], p2x[i + 1], p2y[i + 1], pen);
      tft.drawLine(p2x[i + 4], p2y[i + 4], p2x[i + 5], p2y[i + 5], pen);
      tft.drawLine(p2x[i], p2y[i], p2x[i + 4], p2y[i + 4], pen);
    }
    tft.drawLine(p2x[3], p2y[3], p2x[0], p2y[0], pen);
    tft.drawLine(p2x[7], p2y[7], p2x[4], p2y[4], pen);
    tft.drawLine(p2x[3], p2y[3], p2x[7], p2y[7], pen);


        #ifndef ONLY_CUBE
    //----- Duszki -----//
    tft.ofs( 20, 20 );
    uint8_t static s0x = 10, s0y = 10;
    tft.drawSprite_P(s0x, s0y, s0x + duch_x - 1, s0y + duch_y - 1, duch_G, duch_x * duch_y ); // sx + szerokość - 1, sy + wysokosc - 1
    s0x++; if ( s0x > 140 ) s0x = 0;
    s0y++; if ( s0y > 140 ) s0y = 0;

    uint8_t static s1x = 100, s1y = 100;
    tft.drawSprite_P(s1x, s1y, s1x + duch_x - 1, s1y + duch_y - 1, duch_M, duch_x * duch_y ); // sx + szerokość - 1, sy + wysokosc - 1
    s1x--; if ( s1x < 1 ) s1x = 140;
    s1y--; if ( s1y < 1 ) s1y = 140;

    {
      uint8_t static kier;
      uint32_t static tm;
      if ( millis() > tm ) {
        tm = millis() + 2000;
        kier ^= 1;
      }
      uint8_t static s2x = 0, s2y = 100;
      if ( kier )tft.drawSprite_P(s2x, s2y, s2x + duch_x - 1, s2y + duch_y - 1, duch_C, duch_x * duch_y ); // sx + szerokość - 1, sy + wysokosc - 1
      else tft.drawSprite_P(s2x, s2y, s2x + duch_x - 1, s2y + duch_y - 1, duch_Cb, duch_x * duch_y ); // sx + szerokość - 1, sy + wysokosc - 1
      s2x++; if ( s2x > 140 ) s2x = 0;
      s2y--; if ( s2y < 1 ) s2y = 140;
      tft.ofs( 0, 0 );
    }
#endif


    //----- Wyswietlenie -----//
    uint32_t czasRysowaniaE = millis();
    uint32_t czasS = micros();
    tft.display();
    uint32_t czasE = micros();
    //delay(35);

    /*
        word t1 = tft.readAdrDMA();
        word t2 = tft.readAdrDMA();
        word t3 = tft.readAdrDMA();
        delay(15);
        word t4 = tft.readAdrDMA();
        delay(15);
        word t5 = tft.readAdrDMA();
        delay(15);
        word t6 = tft.readAdrDMA();
    */


    //----- Pomiary -----//
    {
      char txt[50];
      uint32_t static tm;
      if ( millis() > tm ) {
        tm = millis() + 2000;

        //sprintf( txt, "%x %x %x %x %x %x ", t1, t2, t3, t4, t5, t6 ); Serial.print( txt );

        sprintf( txt, "GFX=%dms, Display=%dus", czasRysowaniaE - czasRysowaniaS, czasE - czasS ); Serial.print( txt );

        uint8_t static pwm;
        tft.setPWM( pwm );
        tft.setOUT( 1 << ( pwm & 3) );
        pwm++;
        sprintf( txt, " In=%x Out=%x Pwm=%d",  tft.readIN(),  tft.readOUT(),  tft.readPWM()  ); Serial.println( txt );
      }
    }
  }




}
